package org.jeecg.modules.sensor.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.device.entity.BuDevice;
import org.jeecg.modules.device.service.IBuDeviceService;
import org.jeecg.modules.sensor.entity.BuItemExplain;
import org.jeecg.modules.sensor.service.IBuItemExplainService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Arrays;

 /**
 * @Description: 检测项说明表
 * @Author: jeecg-boot
 * @Date:   2021-10-23
 * @Version: V1.0
 */
@Api(tags="检测项说明表")
@RestController
@RequestMapping("/sensor/buItemExplain")
@Slf4j
public class BuItemExplainController extends JeecgController<BuItemExplain, IBuItemExplainService> {
	@Autowired
	private IBuItemExplainService buItemExplainService;
	@Autowired
	private IBuDeviceService buDeviceService;



	/**
	 * 分页列表查询
	 *
	 * @param buItemExplain
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	@AutoLog(value = "检测项说明表-分页列表查询")
	@ApiOperation(value="检测项说明表-分页列表查询", notes="检测项说明表-分页列表查询")
	@GetMapping(value = "/list")
	public Result<?> queryPageList(BuItemExplain buItemExplain,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<BuItemExplain> queryWrapper = QueryGenerator.initQueryWrapper(buItemExplain, req.getParameterMap());
		Page<BuItemExplain> page = new Page<BuItemExplain>(pageNo, pageSize);
		IPage<BuItemExplain> pageList = buItemExplainService.page(page, queryWrapper);
		return Result.OK(pageList);
	}

	/**
	 *   添加
	 *
	 * @param buItemExplain
	 * @return
	 */
	@AutoLog(value = "检测项说明表-添加")
	@ApiOperation(value="检测项说明表-添加", notes="检测项说明表-添加")
	@PostMapping(value = "/add")
	public Result<?> add(@RequestBody BuItemExplain buItemExplain) {
//		if (buItemExplain.getDeviceId() != null){
//			BuDevice buDevice = buDeviceService.getById(buItemExplain.getDeviceId());
//			buItemExplain.setDeviceName(buDevice.getDeviceName());
//			buItemExplain.setItemStatus(0);
//			buItemExplain.setStatusOne(0);
//			buItemExplain.setStatusTwo(0);
//			buItemExplain.setStatusThree(0);
//			buItemExplain.setStatusFour(0);
			buItemExplainService.save(buItemExplain);
			return Result.OK("添加成功！");
//		}else{
//			return Result.error("请填写设备名称");
//		}
	}

	/**
	 *  编辑
	 *
	 * @param buItemExplain
	 * @return
	 */
	@AutoLog(value = "检测项说明表-编辑")
	@ApiOperation(value="检测项说明表-编辑", notes="检测项说明表-编辑")
	@PutMapping(value = "/edit")
	public Result<?> edit(@RequestBody BuItemExplain buItemExplain) {
		buItemExplainService.updateById(buItemExplain);
		return Result.OK("编辑成功!");
	}

	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "检测项说明表-通过id删除")
	@ApiOperation(value="检测项说明表-通过id删除", notes="检测项说明表-通过id删除")
	@DeleteMapping(value = "/delete")
	public Result<?> delete(@RequestParam(name="id",required=true) String id) {
		buItemExplainService.removeById(id);
		return Result.OK("删除成功!");
	}

	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "检测项说明表-批量删除")
	@ApiOperation(value="检测项说明表-批量删除", notes="检测项说明表-批量删除")
	@DeleteMapping(value = "/deleteBatch")
	public Result<?> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.buItemExplainService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}

	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "检测项说明表-通过id查询")
	@ApiOperation(value="检测项说明表-通过id查询", notes="检测项说明表-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<?> queryById(@RequestParam(name="id",required=true) String id) {
		BuItemExplain buItemExplain = buItemExplainService.getById(id);
		if(buItemExplain==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(buItemExplain);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param buItemExplain
    */
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, BuItemExplain buItemExplain) {
        return super.exportXls(request, buItemExplain, BuItemExplain.class, "检测项说明表");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, BuItemExplain.class);
    }

}
